//
//  SpeechView.m
//  QihooSpeechDemo
//
//  Created by 郑善福 on 15/11/23.
//  Copyright © 2015年 郑善福. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "SpeechView.h"
#define APPID @"51de5743"
#define TIMEOUT @"20000"
// timeout      连接超时的时间，以ms为单位，毫秒，符号ms ，1000 毫秒 = 1秒，30000=30秒
//timeout:网络超时时间,单位:ms,默认为20000,范围0-30000
@implementation SpeechAlertView

-(id)init
{
    self = [super initWithFrame:CGRectMake(0, 0, 300, 220)];
    if (self) {
        // Initialization code
        
        self.appid = [[NSString alloc] initWithFormat:@"msearch"];
        self.securetKey = [[NSString alloc] initWithFormat:@"9ACnlfTCwxjpLMqB88vfnaAPZIE="];
    }
    return self;
}
- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
        
    }
    return self;
}

//uialertview的大小位置
-(void)setFrame:(CGRect)frame{
    //重新设置弹出框的大小和位置
    UIWindow *window =  [UIApplication sharedApplication].keyWindow;
    
    [super setFrame:CGRectMake((window.frame.size.width-self.frame.size.width)/2, (window.frame.size.height-self.frame.size.height)/2, self.frame.size.width, self.frame.size.height)];
}
//重新写界面内容
- (void) layoutSubviews {
    //屏蔽系统的ImageView 和 UIButton
    for (UIView *v in [self subviews]) {
        if ([v class] == [UIImageView class]){
            [v setHidden:YES];
        }
        
        
        if ([v isKindOfClass:[UIButton class]] ||
            [v isKindOfClass:NSClassFromString(@"UIThreePartButton")]) {
            [v setHidden:YES];
        }
    }
    
    //添加背影图
    UIView *backView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height)];
    backView.backgroundColor = [UIColor colorWithRed:66/255.0 green:68/255.0 blue:70/255.0 alpha:1.0];
    [self addSubview:backView];
    
    //添加标题
    UILabel *titleLabel = [[UILabel alloc]initWithFrame:CGRectMake(10, 0, backView.frame.size.width-20, 30)];
    titleLabel.backgroundColor = [UIColor clearColor];
    titleLabel.text = @"语音识别";
    titleLabel.font = [UIFont systemFontOfSize:16];
    titleLabel.textColor = [UIColor colorWithRed:218.0/255.0 green:217.0/255.0 blue:217.0/255.0 alpha:1];
    [backView addSubview:titleLabel];
    
    //添加关闭按钮huati_close
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    [button setImage:[UIImage imageNamed:@"alert_close.png"] forState:UIControlStateNormal];
    [backView addSubview:button];
    button.tag = 1;
    button.frame = CGRectMake(backView.frame.size.width-25, 5, 20, 20);
    [button addTarget:self action:@selector(buttonClicked:) forControlEvents:UIControlEventTouchUpInside];
    
    //添加黄线
    UIView *xianView = [[UIView alloc]initWithFrame:CGRectMake(0, 30, backView.frame.size.width, 1)];
    xianView.backgroundColor = [UIColor yellowColor];
    [backView addSubview:xianView];
    
    //添加内容
    UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 35, backView.frame.size.width, 40)];
    label.backgroundColor = [UIColor clearColor];
    label.text = @"默认不讲话5秒后自动关闭，间隔不讲话2秒后关闭，最多说20秒";
    label.font = [UIFont boldSystemFontOfSize:15];
    label.textAlignment = UITextAlignmentCenter;
    label.textColor = [UIColor yellowColor];
    [backView addSubview:label];
    label.numberOfLines = 0;
    
    //添加中间图片
    speechImage = [[UIImageView alloc]initWithFrame:CGRectMake((self.frame.size.width-50)/2, 80, 50, 85)];
    speechImage.image = [UIImage imageNamed:@"yuyin_01.png"];
    [backView addSubview:speechImage];
    
    //添加说完了按钮
    UIButton *submitButton = [UIButton buttonWithType:UIButtonTypeCustom];
    
    submitButton.frame = CGRectMake((backView.frame.size.width-170)/2, 170, 150, 35);
    submitButton.tag = 2;
    [submitButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [submitButton setTitle:@"说完了" forState:UIControlStateNormal];
    [submitButton setBackgroundImage:[UIImage imageNamed:@"alert_tButton.png"] forState:UIControlStateNormal];
    [submitButton addTarget:self action:@selector(buttonClicked:) forControlEvents:UIControlEventTouchUpInside];
    [backView addSubview:submitButton];
    //想添加什么由此添加
    
    //创建对象
    NSString *initString = [[NSString alloc] initWithFormat:@"appid=%@,timeout=%@",APPID,TIMEOUT];
    //语音识别对象创建
    self.mSpeechRecognizer = [[QihooSpeechRecognizer alloc] init];
    BOOL result = [self.mSpeechRecognizer initWithParam:self.appid SecuretKey:self.securetKey];
    if (result) {
        self.mSpeechConfiger = [[QihooSpeechConfig alloc] init];
        self.mSpeechConfiger.mBUseEndPoint = NO;
        //        self.mSpeechConfiger.mSilMaxLenS = 3;    /*尾点检测模式参数，开始3s不说话，结束*/
        //        self.mSpeechConfiger.mSpeechEndSilLenS = 1; /*尾点检测模式参数，间断1s不说话，结束*/
        [self.mSpeechRecognizer setConfig:self.mSpeechConfiger];
        [self.mSpeechRecognizer setDelegate:self];
        
    }else{
        return;
    }
    
    initString = nil;
    
    //开始识别
    [self.mSpeechRecognizer startListening];
    
}
//按钮处理方法
-(void) buttonClicked:(id)sender
{
    [self dismissWithClickedButtonIndex:0 animated:YES];
    
}

//显示
-(void)show
{
    //    [super show];
    UIWindow *window =  [UIApplication sharedApplication].keyWindow;
    backgroundView = [[UIView alloc]initWithFrame:window.frame];
    backgroundView.backgroundColor = [UIColor clearColor];
    [backgroundView addSubview:self];
    [window addSubview:backgroundView];
}
//弹出框消失
-(void)dismissWithClickedButtonIndex:(NSInteger)buttonIndex animated:(BOOL)animated
{
    [self.mSpeechRecognizer stopListening];
    [self.mSpeechRecognizer cancel];
    [self.mSpeechRecognizer setDelegate:nil];
    self.mSpeechRecognizer = nil;
    speechImage = nil;
    [backgroundView removeFromSuperview];
    backgroundView = nil;
}

#pragma mark -
#pragma mark Voice Delegate
- (void) onVolumeChanged: (int)volume
{
    NSLog(@"%d",volume);
    //录音的音量，音量范围1~100
    if (volume>=0 &&volume<=5) {
        speechImage.image = [UIImage imageNamed:@"yuyin_01.png"];
    }else if(volume>5 && volume<=30){
        speechImage.image = [UIImage imageNamed:@"yuyin_02.png"];
    }else{
        speechImage.image = [UIImage imageNamed:@"yuyin_03.png"];
    }
}


-(void)onBufferReceived:(NSData*) data {
    char *buffer = (char*)[data bytes];
    long len  = [data length];
    
#define POWDER_MAX_VALUE 100
#define POWDER_MIN_VALUE 1
    short *p = (short*)buffer;
    long sl = len / 2;
    
    if (sl > 0 && NULL != buffer){
        long power = 0;
        for(int i = 0; i < sl; i++){
            power += p[i] * p[i];
        }
        power = sqrt(power / sl);
        
        //power = power/40;
        power = power / 20;
        //power = log2(power);
        
        power = MIN(POWDER_MAX_VALUE, power);
        power = MAX(POWDER_MIN_VALUE, power);
        //        DLog(@"Vol: %ld", power);
        if (power >= 5) {
            CGFloat radius = power/100.0 * (60 - 40) + 40;
            speechImage.image = [UIImage imageNamed:@"yuyin_03.png"];
        }else{
            speechImage.image = [UIImage imageNamed:@"yuyin_01.png"];
        }
    }
}

-(void)onBeginningOfSpeech {
    //[self.mBtnTip setText:@"请说话"];
    //    [self.mBtnTip setText:@"倾听中"];
    
}

-(void)onEndOfSpeech {
    
}
-(void)onReadyForSpeech{
    //    [self.mBtnTip setText:@"请等待"];
}

- (void) onError:(int ) error
{
    NSLog(@"停止录音%d",error);
    [self dismissWithClickedButtonIndex:0 animated:YES];
}

//解析返回的array的识别结果为string
-(NSString *)stringFromArray:(NSArray*) res{
    NSMutableString *strQuery = [[NSMutableString alloc] initWithString:@""];
    for (int i = 0; i < res.count; i++) {
        if ([res[i] isKindOfClass:[NSString class]]) {
            NSString *str = (NSString *)res[i];
            if (str.length == 0){
                continue;
            }
            if (0 != i) {
                [strQuery appendString:@" "];
            }
            [strQuery appendString:str];
        }
    }
    return strQuery;
}

//结果
- (void) onResults:(NSMutableArray *) results
{
    NSString *strQuery = [self stringFromArray:results];
    
    if (strQuery.length == 0) {
        [self onError:ERROR_SPEECH_TIMEOUT];
    }else {
        [_speechDelegate getResultText:strQuery];
    }
    
    NSLog(@"转写结果：%@--results:%@",strQuery,results);
    
    //返回结果
    //[_speechDelegate getNResultText:result];
}

//TODO:
- (void) onPartialResults:(NSMutableArray *) results
{
    NSString *strQuery = [self stringFromArray:results];
    if (strQuery.length != 0) {
        [_speechDelegate getResultText:strQuery];
    }
}
@end
